;++++++++++++++++++++++++
;+++ Alternativmediensuche v1.1 +++
;++++++++++++++++++++++++

#cs:	nderungen gegenber der Version 1.0:

		1. Die erste und wichtigste Konfiguration ist die des Browserpfades. Wenn diese nicht durchgefhrt wurde (Autoit FileExists), dann startet das Programm nicht.

#ce;

#include <StringConstants.au3>
#include <AutoItConstants.au3>
#include <WindowsConstants.au3>
#include <MsgBoxConstants.au3>
#include <WinAPISysWin.au3>
#include <GuiListBox.au3>

;Programm abbrechen ber die Escape Taste:
HotKeySet("{ESC}", "ExitProgram")

; ConsoleWrite($ & @CRLF)
; Dateien lesen: Ab Zeile 100, aber 144 eingeben;

$startrowUserList = 1
$windowName = ""

;Strings:
$browserFile = ""		;Dateiname, in der die Browserdaten stehen
$browserString = ""	;String zur Sammlung aller Browserpfade, die der User angegeben hat
$browserNumber = "";Nummer des vollstndigen Pfads, der auch zur Auswahl der Mausklick Datei zur Anwendung kommt
$browserpfad = ""		;der einzelne Browserpfad, dar dann zur Anwendung kommt
$advancedSearch = "https://www.google.de/advanced_search"
$allWords = ""
$wordGroup = ""
$oneoftheseWords = ""
$noneoftheseWords = ""
$numbersFrom = ""
$numbersTo = ""
$noRobot_yes_no = ""

;Koordinaten-Strings:
$allWords_xy = ""
$wordGroup_xy = ""
$oneoftheseWords_xy = ""
$noneoftheseWords_xy = ""
$numbersFrom_xy = ""
$numbersTo_xy = ""

$advancedSearchURL_xy = ""
$nameofWebsite_xy = ""
$erweiterteSucheButton_xy = ""
$noRobot_xy = ""

;Dropdown-Boxen:
$language_xy = ""
$land_xy = ""
$lastRev_xy = ""
$where_xy = ""
$type_xy = ""
$license_xy = ""

;Integers:
$advancedSearchURL_x = 0
$advancedSearchURL_y = 0
$allWords_x = 0
$allWords_y = 0
$wordGroup_x = 0
$wordGroup_y = 0
$oneoftheseWords_x = 0
$oneoftheseWords_y = 0
$noneoftheseWords_x = 0
$noneoftheseWords_y = 0
$numbersFrom_x = 0
$numbersFrom_y = 0
$numbersTo_x = 0
$numbersTo_y = 0
$nameofWebsite_x = 0
$nameofWebsite_y = 0
$erweiterteSucheButton_x = 0
$erweiterteSucheButton_y = 0
$noRobot_x = 0
$noRobot_y = 0

;Integers der Dropdown-Boxen Koordinaten:
$language_x = 0
$language_y = 0
$land_x = 0
$land_y = 0
$lastRev_x = 0
$lastRev_y = 0
$where_x = 0
$where_y = 0
$type_x = 0
$type_y = 0
$license_x = 0
$license_y = 0

;Integers der Dropdown-Boxen: Anzahl der Abwrtsklicks
$language = 0
$land = 0
$lastRev = 0
$where = 0
$type = 0
$license = 0

;Dateinamen:
$currentDir = @WorkingDir
$browserFile = $currentDir & "\uBrowsersteuerung.txt"
$suchString = $currentDir & "\uSuchstring.txt"
$mausklick = $currentDir & "\" ;der Dateiname steht an dieser Stelle noch nicht fest
$mediaList = $currentDir & "\" ;der Dateiname steht an dieser Stelle noch nicht fest

#cs:	
		In der Browsersteuerung kann der User beliebig viele Browserpfade angeben. Das ist die einzige Stelle, an der der Benutzer die Vorgaben macht. 
		Daher knnte ich an dieser Stelle ein Dictionary gut gebrauchen, das es aber in Autoit nicht gibt. Da es sich aber um einzulesende Strings handelt, 
		kann ich ein Dictionary ber die Strings ziemlich gut simulieren. Beispiel [1]C:\Program Files\Google\Chrome\Application\chrome.exe\n. Vor dem
		Browserstart kann ich ber ein Stringsplit ( "string", "delimiters" [, flag = 0] ) den anwendbaren Browserpfad leicht ermitteln.
#ce


;++++++++++++++++++++++++++++++++++
;+++ ffne und lies die Browsersteuerung Datei @@@ 1. Datei: Browsersteuerung
;++++++++++++++++++++++++++++++++++

$hFile = FileOpen($browserFile, $FO_READ)
If $hFile = -1 Then
    MsgBox(BitOR($MB_OK, $MB_ICONERROR), "Error", "Die Datei uBrowsersteuerung.txt wurde nicht gefunden.")
    Exit
EndIf

While 1
	$row = FileReadLine($hFile)
	If @error = -1 Then ExitLoop ; End of file reached
    If StringMid($row, 1, 1) = "#" Then ContinueLoop ;wenn eine Zeile mit dem Hashzeichen beginnt, dann ist sie auskommentiert
		
    ; Zeilenverarbeitung:
	If StringInStr($row, "Vollstndiger Browserpfad") > 0 Then 
		$browserpfad = getUserInput($row)		
		$browserNumber = getBrowserNumber($row)
		$browserString = $browserString & "[" & $browserNumber & "]" & $browserPfad & @CRLF		
	EndIf
	If StringInStr($row, "Ich bin kein Roboter:") > 0 Then $noRobot_yes_no = getUserInput($row)		
WEnd

FileClose($hFile) 


;+++++++++++++++++++++++++++++
;+++ ffne und lies die Suchstring Datei @@@ 2. Datei: Suchstring
;+++++++++++++++++++++++++++++

;ffne die Suchstring Datei:
$hFile = FileOpen($suchString, $FO_READ)
If $hFile = -1 Then
    MsgBox(BitOR($MB_OK, $MB_ICONERROR), "Error", "Die Datei uSuchstring.txt wurde nicht gefunden.")
    Exit
EndIf

; Lies die Suchstring Datei zeilenweise:
While 1
	$row = FileReadLine($hFile)
	If @error = -1 Then ExitLoop ; End of file reached
	If StringMid($row, 1, 1) = "#" Then ContinueLoop ;wenn eine Zeile mit dem Hashzeichen beginnt, dann ist sie auskommentiert
    
    ; Zeilenverarbeitung: Vollstndiger Browserpfad
	If StringInStr($row, "Vollstndiger Browserpfad Nr.:") > 0 Then 		
		$strKey = "[" & getUserInput($row) & "]"
		$strDic = StringSplit ( $browserString, @CRLF, $STR_ENTIRESPLIT)
		For $i = 1 To $strDic[0]
			$pos = StringInStr($strDic[$i], $strKey) 			
			If $pos > 0 Then 				
				$browserNumber = getUserInput($row)				
				$browserpfad = StringRight($strDic[$i], StringLen($strDic[$i]) - $pos - StringLen($strKey) + 1)		
				$mausklick = $mausklick & "uMausklick" & $browserNumber & ".txt"					
				ExitLoop				
			EndIf
		Next	
	EndIf
	
	;Anwendbare Alternativmedienliste:	@@@@@
	$pos = 	StringInStr($row, "Webseiten-Liste Nr.:") 	
	If $pos > 0 Then
			$userInput = getUserInput($row)
			$listNum = $userInput
			$startrowUserList = 1
			If StringInStr($row, ",") > 0 Then
				$listNum = getMouseCoordinates($userInput, "x")
				$startrowUserList = getMouseCoordinates($userInput, "y")				
			EndIf
			$mediaList = $mediaList & "uListe" & $listNum & ".txt"			
	EndIf	
	
	;Eingabefelder:
	If StringInStr($row, "Alle diese Wrter:") > 0 Then $allWords = getUserInput($row)
	If StringInStr($row, "Genau diese Wortgruppe:") > 0 Then $wordGroup = getUserInput($row)
	If StringInStr($row, "Eines dieser Wrter:") > 0 Then $oneoftheseWords = getUserInput($row)
	If StringInStr($row, "Keines von diesen Wrtern:") > 0 Then $noneoftheseWords = getUserInput($row)
	If StringInStr($row, "Zahlen von:") > 0 Then $numbersFrom = getUserInput($row)
	If StringInStr($row, "Zahlen bis:") > 0 Then $numbersTo = getUserInput($row)
		
	;Dropdown-Boxen:
	If StringInStr($row, "Sprache:") > 0 Then $language = Number(getUserInput($row))
	If StringInStr($row, "Land:") > 0 Then $land = Number(getUserInput($row))
	If StringInStr($row, "Letzte Aktualisierung:") > 0 Then $lastRev = Number(getUserInput($row))
	If StringInStr($row, "Begriffe erscheinen:") > 0 Then $where = Number(getUserInput($row))
	If StringInStr($row, "Dateityp:") > 0 Then $type = Number(getUserInput($row))
	If StringInStr($row, "Nutzungsrechte:") > 0 Then $license = Number(getUserInput($row))
			
WEnd

FileClose($hFile) ;die $suchString Datei


;++++++++++++++++++++++++++++
;+++ ffne und lies die Mausklick Datei @@@ 3. Datei: Mausklick
;++++++++++++++++++++++++++++

;ffne die Mausklick Datei:		
$hFile = FileOpen($mausklick, $FO_READ)
If $hFile = -1 Then
    MsgBox(BitOR($MB_OK, $MB_ICONERROR), "Error", "Die Datei uMausklick.txt wurde nicht gefunden.")
    Exit
EndIf

; Lies die Mausklick Datei zeilenweise:
While 1
	$row = FileReadLine($hFile)
	If @error = -1 Then ExitLoop ; End of file reached
	If StringMid($row, 1, 1) = "#" Then ContinueLoop ;wenn eine Zeile mit dem Hashzeichen beginnt, dann ist sie auskommentiert
    
    ; Zeilenverarbeitung:
	If StringInStr($row, "Eingabe der Advanced Search URL:") > 0 Then $advancedSearchURL_xy = getUserInput($row)
	If StringInStr($row, "Alle diese Wrter:") > 0 Then $allWords_xy = getUserInput($row)
	If StringInStr($row, "Genau diese Wortgruppe:") > 0 Then $wordGroup_xy = getUserInput($row)
	If StringInStr($row, "Eines dieser Wrter:") > 0 Then $oneoftheseWords_xy = getUserInput($row)
	If StringInStr($row, "Keines von diesen Wrtern:") > 0 Then $noneoftheseWords_xy = getUserInput($row)
	If StringInStr($row, "Zahlen von:") > 0 Then $numbersFrom_xy = getUserInput($row)
	If StringInStr($row, "Zahlen bis:") > 0 Then $numbersTo_xy = getUserInput($row)
	If StringInStr($row, "Website oder Domain:") > 0 Then $nameofWebsite_xy = getUserInput($row)	
	If StringInStr($row, "Erweiterte Suche Button:") > 0 Then $erweiterteSucheButton_xy = getUserInput($row)	
	If StringInStr($row, "Ich bin kein Roboter:") > 0 Then $noRobot_xy = getUserInput($row)	
	
	;Dropdownboxen:	
	If StringInStr($row, "Sprache:") > 0 Then $language_xy = getUserInput($row)
	If StringInStr($row, "Land:") > 0 Then $land_xy = getUserInput($row)
	If StringInStr($row, "Letzte Aktualisierung:") > 0 Then $lastRev_xy = getUserInput($row)
	If StringInStr($row, "Begriffe erscheinen:") > 0 Then $where_xy = getUserInput($row)
	If StringInStr($row, "Dateityp:") > 0 Then $type_xy = getUserInput($row)
	If StringInStr($row, "Nutzungsrechte:") > 0 Then $license_xy = getUserInput($row)
	
WEnd

FileClose($hFile) ;die $mausklick Datei


;++++++++++++++++++++++++++++++++++++++++
;+++ Ermittlung der Mauskoordinaten aus den _xy Strings @@@ 3a. Mauskoordinaten
;++++++++++++++++++++++++++++++++++++++++

$advancedSearchURL_x = getMouseCoordinates($advancedSearchURL_xy, "x")
$advancedSearchURL_y = getMouseCoordinates($advancedSearchURL_xy, "y")
$allWords_x = getMouseCoordinates($allWords_xy, "x")
$allWords_y = getMouseCoordinates($allWords_xy, "y")
$wordGroup_x = getMouseCoordinates($wordGroup_xy, "x")
$wordGroup_y = getMouseCoordinates($wordGroup_xy, "y")
$oneoftheseWords_x = getMouseCoordinates($oneoftheseWords_xy, "x")
$oneoftheseWords_y = getMouseCoordinates($oneoftheseWords_xy, "y")
$noneoftheseWords_x = getMouseCoordinates($noneoftheseWords_xy, "x")
$noneoftheseWords_y = getMouseCoordinates($noneoftheseWords_xy, "y")
$numbersFrom_x = getMouseCoordinates($numbersFrom_xy, "x")
$numbersFrom_y = getMouseCoordinates($numbersFrom_xy, "y")
$numbersTo_x = getMouseCoordinates($numbersTo_xy, "x")
$numbersTo_y = getMouseCoordinates($numbersTo_xy, "y")
$nameofWebsite_x = getMouseCoordinates($nameofWebsite_xy, "x")
$nameofWebsite_y = getMouseCoordinates($nameofWebsite_xy, "y")
$erweiterteSucheButton_x = getMouseCoordinates($erweiterteSucheButton_xy, "x")
$erweiterteSucheButton_y = getMouseCoordinates($erweiterteSucheButton_xy, "y")
$noRobot_x = getMouseCoordinates($noRobot_xy, "x")
$noRobot_y = getMouseCoordinates($noRobot_xy, "y")

;Dropdown Boxen:
$language_x = getMouseCoordinates($language_xy, "x")
$language_y = getMouseCoordinates($language_xy, "y")
$land_x = getMouseCoordinates($land_xy, "x")
$land_y = getMouseCoordinates($land_xy, "y")
$lastRev_x = getMouseCoordinates($lastRev_xy, "x")
$lastRev_y = getMouseCoordinates($lastRev_xy, "y")
$where_x = getMouseCoordinates($where_xy, "x")
$where_y = getMouseCoordinates($where_xy, "y")
$type_x = getMouseCoordinates($type_xy, "x")
$type_y = getMouseCoordinates($type_xy, "y")
$license_x = getMouseCoordinates($license_xy, "x")
$license_y = getMouseCoordinates($license_xy, "y")


;+++++++++++++++++++++++++++++
;+++ ffne und lies die Medien URL Liste @@@ 4. Datei: Medien URL Liste
;+++++++++++++++++++++++++++++

;ffne die konfigurierte Alternativmedien-Liste:
$hFile = FileOpen($mediaList, $FO_READ)
If $hFile = -1 Then
    MsgBox(BitOR($MB_OK, $MB_ICONERROR), "Error", "Die Datei " & $mediaList & " wurde nicht gefunden.")
    Exit
EndIf

;++++++++++++++++
;+++ Browser starten +++
;++++++++++++++++

;Browserpfad verifizieren:
$retVal = FileExists($browserpfad)

If $retVal = 0 Then 
	MsgBox(BitOR($MB_OK, $MB_ICONERROR), "Error", "Der angegebene Browserpfad: " & $browserpfad & " existiert nicht. Bitte den Browserpfad konfigurieren (siehe Hilfe Kapitel 4).")
	Exit
EndIf

;Browser starten:
Sleep(200)
Run($browserpfad, "", @SW_MAXIMIZE)
Sleep(300)

$hBrowser = WinGetHandle("[active]")
WinSetState($hBrowser, "", @SW_MAXIMIZE)	


;+++++++++++++++++++++
;+++ Browser Tabs ausfllen +++
;+++++++++++++++++++++

$rowCounter = 0
$newTabAlreadyCreated = True

;Lies die Medien URL Liste:
While 1
	$row = FileReadLine($hFile)
	
	If @error = -1 Then ExitLoop ; Abbruch 1: End of file reached;
		
	If StringMid($row, 1, 1) = "#" Then ContinueLoop ; Abbruch 2: wenn eine Zeile mit dem Hashzeichen beginnt, dann ist sie auskommentiert;
	
	$rowCounter = $rowCounter + 1	
	If $rowCounter < $startrowUserList Then ContinueLoop ; Abbruch 3: wenn der Benutzer eine 	Startzeilennummer angegeben hat und diese noch nicht erreicht ist;
	    
    ; Zeilenverarbeitung:
	;Create a new Tab:
	If $newTabAlreadyCreated = False Then 
		Send("^t") ;neuer Tab
		Sleep (200)
	EndIf
	
	;Checken, ob das erweiterte Suchfenster bereits geffnet ist: bringt aber nichts, weil Google Chrome den korrekten Namen zurckgibt, das erweiterte Suchfenster aber totzdem manchmal noch nicht auf dem Bildschrm erschienen ist;
	;$sText = WinGetTitle("[ACTIVE]")
	;If StringInStr($sText, "Neuer Tab") == 0 Then Sleep (2000)  ;mit dem Firefox klapp das Auslesen des aktiven Fensters nicht (leerer String) => noch mal eine Sekunde warten und erst danach loslegen;
	
	;URL eingeben:
	MouseClick($MOUSE_CLICK_LEFT, $advancedSearchURL_x, $advancedSearchURL_y)
	Send($advancedSearch)
	Send("{ENTER}")
	Sleep(1000)	
	
	;Alle diese Wrter:
	If $allWords <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $allWords_x, $allWords_y)
		Send($allWords)
		Sleep(100)		
	EndIf
	
	;Genau diese Wortgruppe:
	If $wordGroup <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $wordGroup_x, $wordGroup_y)
		Send($wordGroup)
		Sleep(100)		
	EndIf
	
	;Eines dieser Wrter:	
	If $oneoftheseWords <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $oneoftheseWords_x, $oneoftheseWords_y)
		Send($oneoftheseWords)
		Sleep(100)		
	EndIf
	
	;Keines dieser Wrter:
	If $noneoftheseWords <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $noneoftheseWords_x, $noneoftheseWords_y)
		Send($noneoftheseWords)
		Sleep(100)		
	EndIf
	
	;Zahlen von:
	If $numbersFrom <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $numbersFrom_x, $numbersFrom_y)
		Send($numbersFrom)
		Sleep(100)
	Else
		If $numbersTo = "" Then
			MouseClick($MOUSE_CLICK_LEFT, $numbersFrom_x, $numbersFrom_y)
			Send("@" & String($rowCounter))
			Sleep(100)
		EndIf
	EndIf
	
	;Zahlen bis:
	If $numbersTo <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $numbersTo_x, $numbersTo_y)
		Send($numbersTo)		
		Sleep(100)		
	EndIf
	
	;Website oder Domain:
	If $row <> "" Then
		MouseClick($MOUSE_CLICK_LEFT, $nameofWebsite_x, $nameofWebsite_y)
		Send($row)
		Sleep(100)		
	EndIf
	
	;++++++++++++++++++
	;+++ Dropdown Boxen: +++
	;++++++++++++++++++
	
	;Sprache:
	If $language <> 0 Then
		MouseClick($MOUSE_CLICK_LEFT, $language_x, $language_y)		
		For $i = 1 to $language
			Sleep(10)
			Send("{DOWN}")			
		Next			
		Sleep(50)
		Send("{ENTER}")
		Sleep(500)		
	EndIf
	
	;Land:
	If $land <> 0 Then
		MouseClick($MOUSE_CLICK_LEFT, $land_x, $land_y)		
		For $i = 1 to $land
			Sleep(10)
			Send("{DOWN}")			
		Next			
		Sleep(50)
		Send("{ENTER}")
		Sleep(500)		
	EndIf
	
	;Letzte nderung:
	If $lastRev <> 0 Then
		MouseClick($MOUSE_CLICK_LEFT, $lastRev_x, $lastRev_y)		
		For $i = 1 to $lastRev
			Sleep(10)
			Send("{DOWN}")			
		Next			
		Sleep(50)
		Send("{ENTER}")
		Sleep(500)		
	EndIf	
	
	;Wo auf der Seite:
	If $where <> 0 Then
		MouseClick($MOUSE_CLICK_LEFT, $where_x, $where_y)		
		For $i = 1 to $where
			Sleep(10)
			Send("{DOWN}")			
		Next			
		Sleep(50)
		Send("{ENTER}")
		Sleep(500)		
	EndIf
	
	;Dateityp:
	If $type <> 0 Then
		MouseClick($MOUSE_CLICK_LEFT, $type_x, $type_y)		
		For $i = 1 to $type
			Sleep(10)
			Send("{DOWN}")			
		Next			
		Sleep(50)
		Send("{ENTER}")
		Sleep(500)		
	EndIf
	
	;Lizenztyp:
	If $license <> 0 Then
		MouseClick($MOUSE_CLICK_LEFT, $license_x, $license_y)		
		For $i = 1 to $license
			Sleep(10)
			Send("{DOWN}")			
		Next			
		Sleep(50)
		Send("{ENTER}")
		Sleep(500)		
	EndIf
	
	;+++++++++++++++
	;+++ Ausfhrung @@@
	;+++++++++++++++
	
	;Klicke den Erweiterte Suche Button:
	MouseClick($MOUSE_CLICK_LEFT, $erweiterteSucheButton_x, $erweiterteSucheButton_y)
	Sleep(500)
	
	;Ich bin kein Roboter:
	If $noRobot_yes_no = "true" Or $noRobot_yes_no = "True" Then
		Sleep(500)
		MouseClick($MOUSE_CLICK_LEFT, $noRobot_x, $noRobot_y)
		Sleep(500)		
	EndIf
	
	#cs:	Zufallswartezeiten bringen nichts zur Verhinderung der Roboterabfragen:
			$randomInt = Random (10000, 20000, 1) ;Flag = 1 => Integer			
			;Sleep($randomInt)
	#ce
		
	$newTabAlreadyCreated = False
	
WEnd

FileClose($hFile) 


;+++++++++++++++
;+++ Funktionen: @@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;+++++++++++++++

;Terminate Program through the Escape Key:
Func ExitProgram()
        Exit
EndFunc   ;==>Terminate

Func getBrowserNumber($row)
	Local $pos = StringInStr($row, ":")
	Local $left = StringLeft($row, $pos-1)	
	Local $lenLeft = StringLen($left)
	Local $lenPath = StringLen("Vollstndiger Browserpfad")	
	Local $browserNumber = StringRight($left, $lenLeft-$lenPath)	
	Return StringStripWS($browserNumber, $STR_STRIPLEADING + $STR_STRIPTRAILING)	
EndFunc

Func getUserInput($row)
	Local $len = StringLen($row)
	Local $pos = StringInStr($row, ":")
	Local $userInput = StringMid($row, $pos+1, $len-$pos+1)	
	If $pos = 0 Then Return ""		
	Return StringStripWS($userInput, $STR_STRIPLEADING + $STR_STRIPTRAILING)
EndFunc

Func getMouseCoordinates($valueAsString, $xORy)
	Local $x = ""
	Local $y = ""
	If $valueAsString = "" Then Return 0
	Local $len = StringLen($valueAsString)
	Local $pos = StringInStr($valueAsString, ",") 
	If $pos = 0 Then Return 0 ;es wurde kein Komma gefunden
	If $xORy = "x" Then
		$x = StringMid($valueAsString, 1, $pos-1)		
		Return Number($x)
	Else
		$y = StringMid($valueAsString, $pos+1, $len-$pos+1)		
		Return Number($y)
	EndIf
EndFunc